{$M 65520,40000,40000}

uses PacDoor, Crt, Dos;

var Log : text;
    YesNo, Orig : string[5];
    Hour, Min, Sec, Sec100, i, Year, Month, Date, NotUsed : word;

{ (c) CoNDoR^SP 1997. Rip and die. Originally created 27/02/97 at
  around 21:30. If you use some of the code here, please give me
  credit, and *don't* distribute this outside of CN_BDISC.ZIP! }

Procedure WriteLog(txt : string; last : boolean);
begin
     GetTime(Min,Hour,Sec,Sec100);
     GetDate(Year,Month,Date,NotUsed);

     assign(Log, ParamStr(3)+'\DISCLAIM.LOG');
     append(Log);
     write(Log, '> ');
     if Date<10 then write(Log, '0');
     write(Log, Date, '-');
     if Month=1 then write(Log, 'Jan');
     if Month=2 then write(Log, 'Feb');
     if Month=3 then write(Log, 'Mar');
     if Month=4 then write(Log, 'Apr');
     if Month=5 then write(Log, 'May');
     if Month=6 then write(Log, 'Jun');
     if Month=7 then write(Log, 'Jul');
     if Month=8 then write(Log, 'Aug');
     if Month=9 then write(Log, 'Sep');
     if Month=10 then write(Log, 'Oct');
     if Month=11 then write(Log, 'Nov');
     if Month=12 then write(Log, 'Dec');
     write(Log, ' ');
     if Min<10 then write(Log, '0');
     write(Log, Min, ':');
     if Hour<10 then write(Log, '0');
     write(Log, Hour, ':');
     if Sec<10 then write(Log, '0');
     writeln(Log, Sec, ' ', txt);
     if Last=True then writeln(Log);
     close(Log);
end;

Function GetInput(X,Y,Len,Fore,Back : byte; Prev: string) : string;
var Cur : integer;
    s : string;
    ch : char;
    Done, OverWrite : boolean;

Procedure ReWrite;
var a : integer;
begin
     Xgotoxy(x,y);
     Xwrite(s);
     for a:=length(s)+1 to Len do Xwrite(' ');
     Xgotoxy(X+Cur-1,y);
end;

begin
     Done:=false;
     s:=prev;
     Cur:=length(s)+1;
     Xtextcolor(fore);
     Xtextbackground(back);
     ReWrite;
     OverWrite:=False;
     repeat
          Xread_char(ch);
          case ch of
               #0: if XKeyPressed then begin
                    Xread_char(ch);
                    ch:=UpCase(ch);
                    case ch of
                         #82: if (OverWrite=True) then OverWrite:=False else OverWrite:=True;
                         #83: if (Cur<=length(s)) then delete(s,Cur,1);
                         #71: Cur:=1;
                         #79: Cur:=length(s)+1;
                         #75: if (Cur>1) then dec(Cur);
                         #77: if (Cur<=length(s)) then inc(Cur);
                    end;
               end;
               #13: Done:=True;
                ^Y: begin
                         Cur:=1;
                         s:='';
                    end;
                ^H: if Cur > 1 then begin
                         Xwrite(^H);
                         Xwrite(' ');
                         Xgotoxy(Cur-1,WhereY);
                         delete(s,Cur-1,1);
                         dec(cur);
                    end;
         #32..#255: if (length(s)<Len) or (OverWrite=True) and (Cur<=Len) then begin
                         if (length(s)<Len) then case OverWrite of
                              True : if Cur>length(s) then s:=s+ch else s[Cur]:=ch;
                              False: if Cur<=length(s) then insert(ch,s,Cur) else s:=s+ch;
                         end;
                         if (OverWrite=True) and (Cur<=Len) then s[Cur]:=ch;
                         inc(cur);
                    end;
          end;
          ReWrite;
     until Done=True;
     GetInput:=s;
end;

Procedure ShowHelp;
begin
     writeln(' bEFORE-rA dISCLAIMER dOOR [DISC!.EXE]');
     writeln(' v000000.002235534436969696969g (c) CN 1997');
     writeln(' DISC!.EXE <comport> <baudrate> <path\to\logfile\>');
     halt;
end;

function Exist(FileName: string): Boolean;
var chk: file;
begin
     {$I-}
     assign(chk, FileName);
     reset(chk);
     close(chk);
     {$I+}
     exist:=(IOResult=0) and (FileName<>'');
end;

begin
     if (ParamCount < 3) then ShowHelp;
     if not exist(ParamStr(3)+'\DISCLAIM.LOG') then begin
          assign(Log, ParamStr(3)+'\DISCLAIM.LOG');
          rewrite(Log);
          GetTime(Min,Hour,Sec,Sec100);
          GetDate(Year,Month,Date,NotUsed);
          writeln(Log, '------------------------------------------------------------------------------');
          write(Log, '              disclaimer logfile - created ');
          writeln(Log, Min, ':', Hour, ':', Sec, ' on ', Date, '.', Month, '.', Year);
          writeln(Log, '------------------------------------------------------------------------------');
          writeln(Log);
          close(Log);
     end;

     Dorinit;
     Statfore:=15;
     StatFore2:=14;
     Statback:=3;
     DorDisplay('DISC!.ANS',True);
     WriteLog('user enters the disclaimer door..',False);
     YesNo:=GetInput(77,22,3,15,0,'');
     Orig:=YesNo;
     for i:=1 to Length(YesNo) do YesNo[i]:=UpCase(YesNo[i]);
     while YesNo='' do begin
          YesNo:='';
          YesNo:=GetInput(77,22,3,15,0,'');
          for i:=1 to Length(YesNo) do YesNo[i]:=UpCase(YesNo[i]);
     end;
     if YesNo<>'YES' then begin
          WriteLog('oh dear. user disagreed! they entered "'+Orig+'"',True);
          halt(7);
     end else WriteLog('user agreed! loading the bbs...',True);
end.
